diff --git a/drivers/net/ixgbe/base/ixgbe_common.c b/drivers/net/ixgbe/base/ixgbe_common.c
index 0eb2166..e0dc3b5 100644
--- a/drivers/net/ixgbe/base/ixgbe_common.c
+++ b/drivers/net/ixgbe/base/ixgbe_common.c
@@ -168,13 +168,24 @@ bool ixgbe_device_supports_autoneg_fc(struct ixgbe_hw *hw)
 	switch (hw->phy.media_type) {
 	case ixgbe_media_type_fiber_qsfp:
 	case ixgbe_media_type_fiber:
-		hw->mac.ops.check_link(hw, &speed, &link_up, false);
-		/* if link is down, assume supported */
-		if (link_up)
-			supported = speed == IXGBE_LINK_SPEED_1GB_FULL ?
+		/* flow control autoneg black list */
+		switch (hw->device_id) {
+		case IXGBE_DEV_ID_X550EM_A_SFP:
+		case IXGBE_DEV_ID_X550EM_A_SFP_N:
+		case IXGBE_DEV_ID_X550EM_A_QSFP:
+		case IXGBE_DEV_ID_X550EM_A_QSFP_N:
+			supported = false;
+			break;
+		default:
+			hw->mac.ops.check_link(hw, &speed, &link_up, false);
+			/* if link is down, assume supported */
+			if (link_up)
+				supported = speed == IXGBE_LINK_SPEED_1GB_FULL ?
 				true : false;
-		else
-			supported = true;
+			else
+				supported = true;
+		}
+
 		break;
 	case ixgbe_media_type_backplane:
 		supported = true;
@@ -200,9 +211,10 @@ bool ixgbe_device_supports_autoneg_fc(struct ixgbe_hw *hw)
 		break;
 	}
 
-	ERROR_REPORT2(IXGBE_ERROR_UNSUPPORTED,
-		      "Device %x does not support flow control autoneg",
-		      hw->device_id);
+	if (!supported)
+		ERROR_REPORT2(IXGBE_ERROR_UNSUPPORTED,
+			      "Device %x does not support flow control autoneg",
+			      hw->device_id);
 	return supported;
 }
 
@@ -397,8 +409,8 @@ s32 ixgbe_start_hw_generic(struct ixgbe_hw *hw)
 
 	/* Setup flow control */
 	ret_val = ixgbe_setup_fc(hw);
-	if (ret_val != IXGBE_SUCCESS)
-		goto out;
+	if (ret_val != IXGBE_SUCCESS && ret_val != IXGBE_NOT_IMPLEMENTED)
+		return ret_val;
 
 	/* Cache bit indicating need for crosstalk fix */
 	switch (hw->mac.type) {
@@ -419,8 +431,7 @@ s32 ixgbe_start_hw_generic(struct ixgbe_hw *hw)
 	/* Clear adapter stopped flag */
 	hw->adapter_stopped = false;
 
-out:
-	return ret_val;
+	return IXGBE_SUCCESS;
 }
 
 /**
diff --git a/drivers/net/ixgbe/base/ixgbe_x550.c b/drivers/net/ixgbe/base/ixgbe_x550.c
index 8c2479b..f15449c 100644
--- a/drivers/net/ixgbe/base/ixgbe_x550.c
+++ b/drivers/net/ixgbe/base/ixgbe_x550.c
@@ -660,7 +660,7 @@ s32 ixgbe_init_ops_X550EM_a(struct ixgbe_hw *hw)
 
 	switch (mac->ops.get_media_type(hw)) {
 	case ixgbe_media_type_fiber:
-		mac->ops.setup_fc = ixgbe_setup_fc_fiber_x550em_a;
+		mac->ops.setup_fc = NULL;
 		mac->ops.fc_autoneg = ixgbe_fc_autoneg_fiber_x550em_a;
 		break;
 	case ixgbe_media_type_backplane:
@@ -4119,80 +4119,14 @@ out:
 }
 
 /**
- *  ixgbe_fc_autoneg_fiber_x550em_a - Enable flow control IEEE clause 37
+ *  ixgbe_fc_autoneg_fiber_x550em_a - passthrough FC settings
  *  @hw: pointer to hardware structure
  *
- *  Enable flow control according to IEEE clause 37.
  **/
 void ixgbe_fc_autoneg_fiber_x550em_a(struct ixgbe_hw *hw)
 {
-	u32 link_s1, pcs_an_lp, pcs_an;
-	s32 status = IXGBE_ERR_FC_NOT_NEGOTIATED;
-	ixgbe_link_speed speed;
-	bool link_up;
-
-	/* AN should have completed when the cable was plugged in.
-	 * Look for reasons to bail out.  Bail out if:
-	 * - FC autoneg is disabled, or if
-	 * - link is not up.
-	 */
-	if (hw->fc.disable_fc_autoneg) {
-		ERROR_REPORT1(IXGBE_ERROR_UNSUPPORTED,
-			     "Flow control autoneg is disabled");
-		goto out;
-	}
-
-	hw->mac.ops.check_link(hw, &speed, &link_up, false);
-	if (!link_up) {
-		ERROR_REPORT1(IXGBE_ERROR_SOFTWARE, "The link is down");
-		goto out;
-	}
-
-	/* Check if auto-negotiation has completed */
-	status = hw->mac.ops.read_iosf_sb_reg(hw,
-					 IXGBE_KRM_LINK_S1(hw->bus.lan_id),
-					 IXGBE_SB_IOSF_TARGET_KR_PHY, &link_s1);
-
-	if (status != IXGBE_SUCCESS ||
-	    (link_s1 & IXGBE_KRM_LINK_S1_MAC_AN_COMPLETE) == 0) {
-		DEBUGOUT("Auto-Negotiation did not complete\n");
-		status = IXGBE_ERR_FC_NOT_NEGOTIATED;
-		goto out;
-	}
-
-	/* Determine advertised flow control */
-	status = hw->mac.ops.read_iosf_sb_reg(hw,
-					  IXGBE_KRM_PCS_KX_AN(hw->bus.lan_id),
-					  IXGBE_SB_IOSF_TARGET_KR_PHY, &pcs_an);
-
-	if (status != IXGBE_SUCCESS) {
-		DEBUGOUT("Auto-Negotiation did not complete\n");
-		goto out;
-	}
-
-	/* Determine link parter flow control */
-	status = hw->mac.ops.read_iosf_sb_reg(hw,
-				  IXGBE_KRM_PCS_KX_AN_LP(hw->bus.lan_id),
-				  IXGBE_SB_IOSF_TARGET_KR_PHY, &pcs_an_lp);
-
-	if (status != IXGBE_SUCCESS) {
-		DEBUGOUT("Auto-Negotiation did not complete\n");
-		goto out;
-	}
-
-	status = ixgbe_negotiate_fc(hw, pcs_an, pcs_an_lp,
-				    IXGBE_KRM_PCS_KX_AN_SYM_PAUSE,
-				    IXGBE_KRM_PCS_KX_AN_ASM_PAUSE,
-				    IXGBE_KRM_PCS_KX_AN_LP_SYM_PAUSE,
-				    IXGBE_KRM_PCS_KX_AN_LP_ASM_PAUSE);
-
-out:
-	if (status == IXGBE_SUCCESS) {
-		hw->fc.fc_was_autonegged = true;
-	} else {
-		hw->fc.fc_was_autonegged = false;
-		hw->fc.current_mode = hw->fc.requested_mode;
-	}
+	hw->fc.fc_was_autonegged = false;
+	hw->fc.current_mode = hw->fc.requested_mode;
 }
 
 /**
@@ -4430,120 +4364,6 @@ s32 ixgbe_setup_fc_backplane_x550em_a(struct ixgbe_hw *hw)
 }
 
 /**
- *  ixgbe_setup_fc_fiber_x550em_a - Set up flow control
- *  @hw: pointer to hardware structure
- *
- *  Called at init time to set up flow control.
- **/
-s32 ixgbe_setup_fc_fiber_x550em_a(struct ixgbe_hw *hw)
-{
-	struct ixgbe_mac_info *mac = &hw->mac;
-	s32 rc = IXGBE_SUCCESS;
-	u32 an_cntl4, lctrl, pcs_an;
-
-	DEBUGFUNC("ixgbe_setup_fc_fiber_x550em_a");
-
-	/* Validate the requested mode */
-	if (hw->fc.strict_ieee && hw->fc.requested_mode == ixgbe_fc_rx_pause) {
-		ERROR_REPORT1(IXGBE_ERROR_UNSUPPORTED,
-			      "ixgbe_fc_rx_pause not valid in strict IEEE mode\n");
-		return IXGBE_ERR_INVALID_LINK_SETTINGS;
-	}
-
-	/* Enable clause 37 auto-negotiation in KRM_LINK_CTRL_1 */
-	if (hw->fc.requested_mode == ixgbe_fc_default)
-		hw->fc.requested_mode = ixgbe_fc_full;
-
-	rc = mac->ops.read_iosf_sb_reg(hw,
-				       IXGBE_KRM_LINK_CTRL_1(hw->bus.lan_id),
-				       IXGBE_SB_IOSF_TARGET_KR_PHY, &lctrl);
-	if (rc)
-		return rc;
-
-	lctrl |= IXGBE_KRM_LINK_CTRL_1_TETH_AN_ENABLE;
-	lctrl |= IXGBE_KRM_LINK_CTRL_1_TETH_AN_CLAUSE_37_EN;
-
-	rc = mac->ops.write_iosf_sb_reg(hw,
-					IXGBE_KRM_LINK_CTRL_1(hw->bus.lan_id),
-					IXGBE_SB_IOSF_TARGET_KR_PHY, lctrl);
-	if (rc)
-		return rc;
-
-	/* Enable clause 37 over 73 in KRM_AN_CNTL_4 */
-	rc = mac->ops.read_iosf_sb_reg(hw,
-				       IXGBE_KRM_AN_CNTL_4(hw->bus.lan_id),
-				       IXGBE_SB_IOSF_TARGET_KR_PHY, &an_cntl4);
-	if (rc)
-		return rc;
-
-	an_cntl4 |= IXGBE_KRM_AN_CNTL_4_ECSR_AN37_OVER_73;
-
-	rc = mac->ops.write_iosf_sb_reg(hw,
-					IXGBE_KRM_AN_CNTL_4(hw->bus.lan_id),
-					IXGBE_SB_IOSF_TARGET_KR_PHY, an_cntl4);
-	if (rc)
-		return rc;
-
-	rc = hw->mac.ops.read_iosf_sb_reg(hw,
-					  IXGBE_KRM_PCS_KX_AN(hw->bus.lan_id),
-					  IXGBE_SB_IOSF_TARGET_KR_PHY, &pcs_an);
-
-	if (rc)
-		return rc;
-
-	/* The possible values of fc.requested_mode are:
-	 * 0: Flow control is completely disabled
-	 * 1: Rx flow control is enabled (we can receive pause frames,
-	 *    but not send pause frames).
-	 * 2: Tx flow control is enabled (we can send pause frames but
-	 *    we do not support receiving pause frames).
-	 * 3: Both Rx and Tx flow control (symmetric) are enabled.
-	 * other: Invalid.
-	 */
-	switch (hw->fc.requested_mode) {
-	case ixgbe_fc_none:
-		/* Flow control completely disabled by software override. */
-		pcs_an &= ~(IXGBE_KRM_AN_CNTL_1_SYM_PAUSE |
-			    IXGBE_KRM_AN_CNTL_1_ASM_PAUSE);
-		break;
-	case ixgbe_fc_tx_pause:
-		/* Tx Flow control is enabled, and Rx Flow control is
-		 * disabled by software override.
-		 */
-		pcs_an |= IXGBE_KRM_PCS_KX_AN_ASM_PAUSE;
-		pcs_an &= ~IXGBE_KRM_PCS_KX_AN_SYM_PAUSE;
-		break;
-	case ixgbe_fc_rx_pause:
-		/* Rx Flow control is enabled and Tx Flow control is
-		 * disabled by software override. Since there really
-		 * isn't a way to advertise that we are capable of RX
-		 * Pause ONLY, we will advertise that we support both
-		 * symmetric and asymmetric Rx PAUSE, as such we fall
-		 * through to the fc_full statement.  Later, we will
-		 * disable the adapter's ability to send PAUSE frames.
-		 */
-	case ixgbe_fc_full:
-		/* Flow control (both Rx and Tx) is enabled by SW override. */
-		pcs_an |= IXGBE_KRM_PCS_KX_AN_SYM_PAUSE |
-			   IXGBE_KRM_PCS_KX_AN_ASM_PAUSE;
-		break;
-	default:
-		ERROR_REPORT1(IXGBE_ERROR_ARGUMENT,
-			      "Flow control param set incorrectly\n");
-		return IXGBE_ERR_CONFIG;
-	}
-
-	rc = hw->mac.ops.write_iosf_sb_reg(hw,
-					   IXGBE_KRM_PCS_KX_AN(hw->bus.lan_id),
-					   IXGBE_SB_IOSF_TARGET_KR_PHY, pcs_an);
-
-	/* Restart auto-negotiation. */
-	rc = ixgbe_restart_an_internal_phy_x550em(hw);
-
-	return rc;
-}
-
-/**
  * ixgbe_set_mux - Set mux for port 1 access with CS4227
  * @hw: pointer to hardware structure
  * @state: set mux if 1, clear if 0